;DLL
Structure wAPI_func
   GetProcAddress.l
   LoadLibraryA.l
   LoadLibraryW.l
   LoadLibraryExA.l
   LoadLibraryExW.l
   
   send.l
   recv.l
   
   RemoteAPIInit.l
   RemoteAPIAdd.l
   RemoteAPIExec.l
   
   ReplaceAdd.l
   ReplaceExec.l
   ReplaceExecEx.l
EndStructure
Global wAPI.wAPI_func

Global Hook_Enabled.l, Hook_Loaded.l, LogFile, MyFileName.s, MyFilePath.s, MyDLLAddr, wsock32.l, kernel32

Declare LoadHook(myDLLAddress)
Declare StartHook(myDLLAddress)
Declare StopHook(myDLLAddress)

;- remoteapi.dll Commands
Procedure ReplaceAdd(OldAddress.l,NewAddress.l)
   ProcedureReturn CallFunctionFast(wAPI\ReplaceAdd,OldAddress,NewAddress)
EndProcedure
Procedure ReplaceExec(ProcessBase.l)
   ProcedureReturn CallFunctionFast(wAPI\ReplaceExec,ProcessBase.l)
EndProcedure
Procedure ReplaceExecEx(Address.l)
   ProcedureReturn CallFunctionFast(wAPI\ReplaceExecEx,Address.l)
EndProcedure

Procedure RemoteGetProcAddress_(DLL_intern.l,funktion.s,DLL_extern.l)
  func=GetProcAddress_(DLL_intern,funktion)
  If func
    ProcedureReturn (func-DLL_intern)+DLL_extern
  EndIf
EndProcedure

;/ new Library Commands
#DONT_RESOLVE_DLL_REFERENCES     =$00000001
#LOAD_LIBRARY_AS_DATAFILE        =$00000002
#LOAD_WITH_ALTERED_SEARCH_PATH   =$00000008

Procedure myGetProcAddress(hModule,lpProcName)
   ProcedureReturn ReplaceExecEx(CallFunctionFast(wAPI\GetProcAddress,hModule,lpProcName))
EndProcedure
Procedure myLoadLibraryA(lpLibFileName)
   base=CallFunctionFast(wAPI\LoadLibraryA,lpLibFileName)
   If base
     ReplaceExec(base)
   EndIf
   ProcedureReturn base
EndProcedure
Procedure myLoadLibraryW(lpLibFileName)
   base=CallFunctionFast(wAPI\LoadLibraryW,lpLibFileName)
   If base
     ReplaceExec(base)
   EndIf
   ProcedureReturn base
EndProcedure
Procedure myLoadLibraryExA(lpLibFileName,hFile,dwFlags)
   base=CallFunctionFast(wAPI\LoadLibraryExA,lpLibFileName,hFile,dwFlags)
   If base
     If (dwFlags&#LOAD_LIBRARY_AS_DATAFILE)=0
       If (dwFlags&#DONT_RESOLVE_DLL_REFERENCES)=0
         ReplaceExec(base)
       EndIf
     EndIf 
   EndIf
   ProcedureReturn base
EndProcedure
Procedure myLoadLibraryExW(lpLibFileName,hFile,dwFlags)
   base=CallFunctionFast(wAPI\LoadLibraryExW,lpLibFileName,hFile,dwFlags)
   If base
     If (dwFlags&#LOAD_LIBRARY_AS_DATAFILE)=0
       If (dwFlags&#DONT_RESOLVE_DLL_REFERENCES)=0
         ReplaceExec(base)
       EndIf
     EndIf 
   EndIf
   ProcedureReturn base
EndProcedure

;- other Commands
Procedure mysend(s.l, *buf, len.l, flags.l)
  
  Result.l = CallFunctionFast(wAPI\send, s.l, *buf, len.l, flags.l)
  
  If LogFile
    WriteStringN(LogFile, "<sent>")
    WriteData(LogFile, *buf, len)
    WriteStringN(LogFile, "")
    WriteStringN(LogFile, "</sent>")
  EndIf
  
  ProcedureReturn Result
EndProcedure

Procedure myrecv(s.l, *buf, len.l, flags.l)
  
  Result.l = CallFunctionFast(wAPI\recv, s.l, *buf, len.l, flags.l)
  
  If LogFile
    WriteStringN(LogFile, "<recv>")
    WriteData(LogFile, *buf, len)
    WriteStringN(LogFile, "")
    WriteStringN(LogFile, "</recv>")
  EndIf
  
  ProcedureReturn Result
EndProcedure

;- main function
ProcedureDLL LoadHook(myDLLAddress)
   If Hook_Loaded=0
     MyDLLAddr = myDLLAddress
     If kernel32 = 0
     kernel32=LoadLibrary_("kernel32.dll")
     EndIf
     wAPI\GetProcAddress=GetProcAddress_(kernel32,"GetProcAddress")
     wAPI\LoadLibraryA=GetProcAddress_(kernel32,"LoadLibraryA")
     wAPI\LoadLibraryW=GetProcAddress_(kernel32,"LoadLibraryW")
     wAPI\LoadLibraryExA=GetProcAddress_(kernel32,"LoadLibraryExA")
     wAPI\LoadLibraryExW=GetProcAddress_(kernel32,"LoadLibraryExW")
     
     If wsock32 = 0
     wsock32=LoadLibrary_("wsock32.dll")
     EndIf
     wAPI\send=GetProcAddress_(wsock32,"send")
     wAPI\recv=GetProcAddress_(wsock32,"recv")
     
     MyFileName.s=Space(1024)
     GetModuleFileName_(myDLLAddress,@MyFileName.s,1024)
     MyFilePath.s=GetPathPart(MyFileName)
     If Right(MyFilePath,1)<>"\"
       MyFilePath+"\"
     EndIf
     
     remoteapi=LoadLibrary_(MyFilePath+"remoteapi.dll")
     If remoteapi=0
       ProcedureReturn 0
     EndIf
     
     wAPI\RemoteAPIInit=GetProcAddress_(remoteapi,"RemoteAPIInit")
     wAPI\RemoteAPIAdd=GetProcAddress_(remoteapi,"RemoteAPIAdd")
     wAPI\RemoteAPIExec=GetProcAddress_(remoteapi,"RemoteAPIExec")
     wAPI\ReplaceAdd=GetProcAddress_(remoteapi,"ReplaceAdd")
     wAPI\ReplaceExec=GetProcAddress_(remoteapi,"ReplaceExec")
     wAPI\ReplaceExecEx=GetProcAddress_(remoteapi,"ReplaceExecEx")
     ReplaceAdd(wAPI\GetProcAddress,@myGetProcAddress())
     ReplaceAdd(wAPI\LoadLibraryA,@myLoadLibraryA())
     ReplaceAdd(wAPI\LoadLibraryW,@myLoadLibraryW())
     ReplaceAdd(wAPI\LoadLibraryExA,@myLoadLibraryExA())
     ReplaceAdd(wAPI\LoadLibraryExW,@myLoadLibraryExW())
     ReplaceAdd(wAPI\send,@mysend())
     ReplaceAdd(wAPI\recv,@myrecv())
     
     Hook_Loaded=1
     
     LogFile = CreateFile(#PB_Any, MyFilePath+"DataLog.bin")
   EndIf
   ProcedureReturn ReplaceExec(GetModuleHandle_(0))
EndProcedure

ProcedureDLL StartHook(myDLLAddress.l)
   Hook_Enabled=1
   ProcedureReturn 1
EndProcedure

ProcedureDLL StopHook(myDLLAddress.l)
   Hook_Enabled=0
   ProcedureReturn 1
EndProcedure
; IDE Options = PureBasic v4.00 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 166
; FirstLine = 95
; Folding = ---
; Executable = hook.dll